# Summary

* [前言](README.md)
* [Java](java-yu-yan/README.md)
  * [Java关键字](java-yu-yan/java-guan-jian-zi/README.md)
    * [Java中四种修饰符的限制范围](java-yu-yan/java-guan-jian-zi/java-zhong-si-zhong-xiu-shi-fu-de-xian-zhi-fan-wei.md)
    * [static和final](java-yu-yan/java-guan-jian-zi/static-he-final.md)
  * [容器](java-yu-yan/ji-he/README.md)
    * [容器概述](java-yu-yan/ji-he/ji-he-gai-shu.md)
      * [容器：综述](java-yu-yan/ji-he/collectionzong-shu.md)
      * [Iterator原理及实现](java-yu-yan/ji-he/iteratoryuan-li.md)
      * [fast-fail机制](java-yu-yan/ji-he/fast-failji-zhi.md)
      * [比较器Comparator](java-yu-yan/ji-he/bi-jiao-qi-comparator.md)
      * [Collections工具类](java-yu-yan/ji-he/collectionsgong-ju-lei.md)
    * [List](java-yu-yan/ji-he/list.md)
      * [List综述](java-yu-yan/ji-he/listzong-shu.md)
      * [ArrayList原理分析](java-yu-yan/ji-he/arraylistyuan-li-fen-xi.md)
      * [ArrayList在循环过程中删除元素的问题](java-yu-yan/ji-he/yi-ge-arraylist-zai-xun-huan-guo-cheng-zhong-shan-chu-hui-bu-hui-chu-wen-ti-wei-shi-mo.md)
      * [常用的小技巧](java-yu-yan/ji-he/chang-yong-de-xiao-ji-qiao.md)
      * [CopyOnWrite](java-yu-yan/ji-he/copyonwrite.md)
    * [Set](java-yu-yan/ji-he/set.md)
      * [Set综述](java-yu-yan/ji-he/set/setzong-shu.md)
      * [HashSet](java-yu-yan/ji-he/set/hashmapshi-xian-yuan-li.md)
      * [LinkedHashSet](java-yu-yan/ji-he/set/linkedhashset.md)
      * [TreeSet](java-yu-yan/ji-he/set/treeset.md)
    * [Queue](java-yu-yan/ji-he/queue.md)
      * [Queue综述](java-yu-yan/ji-he/queue/queuezong-shu.md)
      * [ArrayBlockingQueue实现原理](java-yu-yan/ji-he/queue/arrayblockingqueueshi-xian-yuan-li.md)
      * [LinkedBlockingQueue实现原理](java-yu-yan/ji-he/queue/linkedblockingqueuede-shi-xian-yuan-li.md)
      * [高性能无锁队列Disruptor](java-yu-yan/ji-he/queue/gao-xing-neng-wu-suo-dui-lie-disruptor.md)
    * [Map](java-yu-yan/ji-he/map.md)
      * [Map综述](java-yu-yan/ji-he/mapzong-shu.md)
      * [HashMap](java-yu-yan/ji-he/hashmap.md)
        * [HashMap实现原理](java-yu-yan/ji-he/hashmap/shi-xian-yuan-li.md)
        * [HashMap中的位运算](java-yu-yan/ji-he/hashmap/hashmapzhong-de-wei-yun-suan.md)
        * [HashMap其他问题](java-yu-yan/ji-he/hashmap/qi-ta-wen-ti.md)
      * [LinkedHashMap](java-yu-yan/ji-he/linkedhashmap.md)
      * [TreeMap](java-yu-yan/ji-he/treemap.md)
      * [ConcurrentHashMap](java-yu-yan/ji-he/concurrenthashmap.md)
        * [ConcurrentHashMap实现原理JDK1.7](java-yu-yan/ji-he/concurrenthashmapshi-xian-yuan-li.md)
        * [ConcurrentHashMap实现原理JDK1.8](java-yu-yan/ji-he/concurrenthashmapshi-xian-yuan-li-jdk1-8.md)
      * [ConcurrentSkipListMap](java-yu-yan/ji-he/concurrentskiplistmap.md)
      * [Map中key和value的null的问题](java-yu-yan/ji-he/mapzhong-key-he-value-de-null-de-wen-ti.md)
  * [线程](java-yu-yan/xian-cheng/README.md)
    * [线程](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/README.md)
      * [创建线程](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/chuang-jian.md)
      * [线程状态及切换](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/xian-cheng-zhuang-tai-ji-qie-huan.md)
      * [线程中断的理解](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/xian-cheng-zhong-duan-de-li-jie.md)
      * [几种方法的解释](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/ji-zhong-fang-fa-de-jie-shi.md)
      * [用户线程与守护线程](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/yong-hu-xian-cheng-yu-shou-hu-xian-cheng.md)
      * [线程组ThreadGroup](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/xian-cheng-zu.md)
    * [线程池](java-yu-yan/xian-cheng/xian-cheng-chi/README.md)
      * [线程池工作原理及创建](java-yu-yan/xian-cheng/xian-cheng-chi/xian-cheng-chi-lei-xing-ji-gong-zuo-yuan-li.md)
      * [Executor](java-yu-yan/xian-cheng/xian-cheng-chi/executor.md)
      * [如何确保同一属性的任务被同一线程执行](java-yu-yan/xian-cheng/xian-cheng-chi/ru-he-que-bao-tong-yi-shu-xing-de-ren-wu-bei-tong-yi-xian-cheng-zhi-hang.md)
    * [ThreadLocal](java-yu-yan/xian-cheng/threadlocal/README.md)
      * [ThreadLocal原理](java-yu-yan/xian-cheng/threadlocal/threadlocal.md)
      * [ThreadLocal之父子线程传值](java-yu-yan/xian-cheng/threadlocal/threadlocal-zhi-fu-zi-xian-cheng-chuan-zhi.md)
      * [InheritableThreadLocal](java-yu-yan/xian-cheng/threadlocal/inheritablethreadlocal.md)
    * [同步与锁](java-yu-yan/xian-cheng/tong-bu-yu-suo/README.md)
      * [线程安全与锁优化](java-yu-yan/xian-cheng/tong-bu-yu-suo/xian-cheng-an-quan-yu-suo-you-hua.md)
      * [synchronize关键字](java-yu-yan/xian-cheng/tong-bu-yu-suo/synchronize-guan-jian-zi.md)
      * [Lock](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei.md)
        * [队列同步器](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/tong-bu-qi-yuan-li.md)
          * [同步状态的获取与释放](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/tong-bu-qi-yuan-li/tong-bu-zhuang-tai-de-huo-qu-yu-shi-fang.md)
          * [使用方式](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/tong-bu-qi-yuan-li/shi-li.md)
          * [示例：Mutex](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/tong-bu-qi-yuan-li/shi-li-1.md)
          * [示例：TwinsLock](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/tong-bu-qi-yuan-li/shi-liff1a-twinslock.md)
        * [重入锁和读写锁](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/zhong-ru-suo-he-du-xie-suo.md)
        * [LockSupport](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/locksupport.md)
        * [Condition](java-yu-yan/xian-cheng/tong-bu-yu-suo/lock-ji-shi-xian-lei/condition.md)
        * [并发工具类](java-yu-yan/xian-cheng/xian-cheng-zhuang-tai/bing-fa-liu-cheng-kong-zhi-gong-ju-lei.md)
      * [CAS](java-yu-yan/xian-cheng/tong-bu-yu-suo/cas-de-li-jie/README.md)
        * [CAS的理解](java-yu-yan/xian-cheng/tong-bu-yu-suo/cas-de-li-jie/casde-li-jie.md)
        * [Java中原子操作类](java-yu-yan/xian-cheng/tong-bu-yu-suo/cas-de-li-jie/javazhong-yuan-zi-cao-zuo-lei.md)
      * [3个经典同步问题](java-yu-yan/xian-cheng/tong-bu-yu-suo/3ge-jing-dian-tong-bu-wen-ti.md)
    * [fork/join的理解](java-yu-yan/xian-cheng/forkjoin-de-li-jie.md)
  * [I/O](java-yu-yan/java-guan-jian-zi/io.md)
    * [I/O概述](java-yu-yan/java-guan-jian-zi/io/iofen-lei.md)
      * [磁盘I/O与网络I/O](java-yu-yan/java-guan-jian-zi/io/ci-pan-i-oyu-wang-luo-i-o.md)
      * [主要接口](java-yu-yan/java-guan-jian-zi/io/zhu-yao-jie-kou.md)
      * [输入流和输出流的使用示例](java-yu-yan/java-guan-jian-zi/io/iofen-lei/shu-ru-liu-he-shu-chu-liu-de-shi-yong-shi-li.md)
      * [InputStream的重复读](java-yu-yan/java-guan-jian-zi/io/inputstreamde-zhong-fu-du.md)
      * [BufferdxxxxStream](java-yu-yan/java-guan-jian-zi/io/iofen-lei/1212.md)
      * [Serailizable](java-yu-yan/java-guan-jian-zi/io/iochang-yong-de-lei/serailizable.md)
      * [File常用方法](java-yu-yan/java-guan-jian-zi/io/filelei-chang-yong-fang-fa.md)
      * [Files和Path](java-yu-yan/java-guan-jian-zi/io/fileshe-paths.md)
      * [RandomAccessFile](java-yu-yan/java-guan-jian-zi/io/iochang-yong-de-lei/randomaccessfile.md)
      * [通过零拷贝实现有效数据传输](java-yu-yan/java-guan-jian-zi/io/tong-guo-ling-kao-bei-shi-xian-you-xiao-shu-ju-chuan-shu.md)
      * [正确地处理文件](java-yu-yan/java-guan-jian-zi/io/zheng-que-di-chu-li-wen-jian.md)
    * [NIO基础](java-yu-yan/java-guan-jian-zi/io/nio/nioji-chu.md)
    * [NIO2](java-yu-yan/java-guan-jian-zi/io/nio2.md)
    * [Netty](java-yu-yan/java-guan-jian-zi/io/netty.md)
      * [Java I/O的演进之路](java-yu-yan/java-guan-jian-zi/io/netty/java-iode-yan-jin-zhi-lu.md)
      * [为什么是Netty](java-yu-yan/java-guan-jian-zi/io/netty/wei-shi-yao-shi-netty.md)
      * [更多](java-yu-yan/java-guan-jian-zi/io/netty/geng-duo.md)
    * [I/O调优](java-yu-yan/java-guan-jian-zi/io/iodiao-you.md)
  * [异常](java-yu-yan/yi-chang/README.md)
    * [异常体系及为什么要有这种异常设计](java-yu-yan/yi-chang/yi-chang-ti-xi-ji-wei-shi-mo-yao-you-zhe-zhong-yi-chang-she-ji.md)
    * [多catch的执行情况](java-yu-yan/yi-chang/duo-catch-de-zhi-hang-qing-kuang.md)
    * [try catch finally 与reture](java-yu-yan/yi-chang/try-catch-finally-yu-reture.md)
    * [异常处理的误区](java-yu-yan/yi-chang/java-yi-chang-chu-li-de-wu-qu-he-jing-yan-zong-jie.md)
    * [Preconditions:方法入参校验工具](java-yu-yan/yi-chang/fang-fa-ru-canxiao-yan-gong-ju-preconditions.md)
  * [枚举](java-yu-yan/mei-ju/README.md)
    * [常见用法](java-yu-yan/mei-ju/chang-jian-yong-fa.md)
    * [枚举类在序列化中的问题](java-yu-yan/mei-ju/rpcxu-lie-hua-zhong-mei-ju-lei-de-wen-ti.md)
  * [注解](java-yu-yan/zhu-jie.md)
    * [概述](java-yu-yan/zhu-jie/gai-shu.md)
    * [Spring中的组合注解的条件注解](java-yu-yan/zhu-jie/zhu-jie-de-ji-cheng-he-zu-he.md)
    * [常用注解](java-yu-yan/zhu-jie/chang-yong-zhu-jie.md)
      * [JSR-330标准注解](java-yu-yan/zhu-jie/chang-yong-zhu-jie/jsr-330biao-zhun-zhu-jie.md)
  * [反射](java-yu-yan/fan-she/README.md)
    * [概述](java-yu-yan/fan-she/gai-shu.md)
    * [内部类的反射](java-yu-yan/fan-she/shi-yong-chang-jing.md)
    * [反射中需要注意的地方](java-yu-yan/fan-she/fan-she-zhong-xu-yao-zhu-yi-de-di-fang.md)
  * [流程控制](java-yu-yan/liu-cheng-kong-zhi/README.md)
    * [switch case without break](java-yu-yan/liu-cheng-kong-zhi/switch-case-without-break.md)
    * [Java: for\(;;\) vs. while\(true\)](java-yu-yan/liu-cheng-kong-zhi/java-for-vs.-while-true.md)
  * [JVM](java-yu-yan/jvm/README.md)
    * [JVM内存结构](java-yu-yan/jvm/jvm-nei-cun-jie-gou.md)
    * [Java内存模型](java-yu-yan/jvm/java-nei-cun-mo-xing.md)
    * [垃圾收集器和内存分配策略](java-yu-yan/jvm/la-ji-shou-ji-qi-he-nei-cun-fen-pei-ce-lve.md)
    * [四种引用类型区别及何时回收](java-yu-yan/jvm/si-zhong-yin-yong-lei-xing-qu-bie-ji-he-shi-hui-shou.md)
    * [类文件结构](java-yu-yan/jvm/lei-wen-jian-jie-gou.md)
    * [类初始化顺序](java-yu-yan/jvm/lei-chu-shi-hua-shun-xu.md)
    * [类加载机制](java-yu-yan/jvm/lei-jia-zai-ji-zhi.md)
    * [虚拟机执行引擎](java-yu-yan/jvm/xu-ni-ji-zhi-xing-yin-qing.md)
    * [逃逸分析](java-yu-yan/jvm/tao-yi-fen-xi.md)
    * [JVM常用配置](java-yu-yan/jvm/jvm-chang-yong-pei-zhi.md)
    * [GC日志分析](java-yu-yan/jvm/gc-ri-zhi-fen-xi.md)
    * [Java8 JVM 参数解读](java-yu-yan/jvm/java8-jvm-can-shu-jie-du.md)
    * 垃圾收集器和内存分配策略
  * [面向对象](java-yu-yan/mian-xiang-dui-xiang/README.md)
    * [Object类中的方法](java-yu-yan/mian-xiang-dui-xiang/object-lei-zhong-de-fang-fa.md)
    * [Class类中的方法](java-yu-yan/mian-xiang-dui-xiang/classlei-zhong-de-fang-fa.md)
    * [值传递还是引用传递？](java-yu-yan/mian-xiang-dui-xiang/zhi-chuan-di-huan-shi-yin-yong-chuan-di.md)
    * [接口和抽象类的区别](java-yu-yan/mian-xiang-dui-xiang/jie-kou-he-chou-xiang-lei-de-qu-bie.md)
    * [深拷贝和浅拷贝](java-yu-yan/mian-xiang-dui-xiang/shen-kao-bei-he-qian-kao-bei.md)
    * [Integer.parseInt\(\)与Interger.valueof\(\)](java-yu-yan/chang-jian-fang-fa-de-li-jie/integer.parseint-yu-interger.valueof.md)
    * [hashCode\(\)与equal\(\)](java-yu-yan/chang-jian-fang-fa-de-li-jie/hashcode-yu-equal.md)
    * [String](java-yu-yan/mian-xiang-dui-xiang/string/README.md)
      * [String池化及intern\(\)方法的作用](java-yu-yan/mian-xiang-dui-xiang/string/stringchi-hua-ji-intern-fang-fa-de-zuo-yong.md)
      * [关于字符串](java-yu-yan/mian-xiang-dui-xiang/string/guan-yu-zi-fu-chuan.md)
  * [序列化](java-yu-yan/xu-lie-hua/README.md)
    * [Java序列化的方式有哪些？](java-yu-yan/xu-lie-hua/java-xu-lie-hua-de-fang-shi-you-na-xie.md)
  * [新特性](java-yu-yan/xin-te-xing/README.md)
    * [流 Stream](java-yu-yan/xin-te-xing/liu-de-gai-nian-you-shi-ji-shi-yong/README.md)
      * [Stream是什么](java-yu-yan/xin-te-xing/liu-de-gai-nian-you-shi-ji-shi-yong/stream-shi-shen-me.md)
      * [Stream API详解](java-yu-yan/xin-te-xing/liu-de-gai-nian-you-shi-ji-shi-yong/stream-shi-yong-shi-li.md)
      * [Stream进阶](java-yu-yan/xin-te-xing/liu-de-gai-nian-you-shi-ji-shi-yong/stream-jin-jie.md)
      * [流编程](java-yu-yan/xin-te-xing/liu-de-gai-nian-you-shi-ji-shi-yong/liu-bian-cheng.md)
      * [其他事项](java-yu-yan/xin-te-xing/liu-de-gai-nian-you-shi-ji-shi-yong/qi-ta-shi-xiang.md)
    * [lambda表达式](java-yu-yan/xin-te-xing/lambda-biao-da-shi.md)
    * [默认方法（Default Methods）](java-yu-yan/xin-te-xing/mo-ren-fang-fa-default-methods.md)
    * [@FunctionalInterface注解](java-yu-yan/xin-te-xing/liu-de-gai-nian-you-shi-ji-shi-yong/functionalinterfacezhu-jie.md)
  * [SPI](java-yu-yan/spi/README.md)
    * [理解SPI](java-yu-yan/spi/spi-shi-shi-mo.md)
  * [字节码](java-yu-yan/zi-jie-ma/README.md)
    * [javaagent](java-yu-yan/zi-jie-ma/javaagent.md)
    * [字节码操纵](java-yu-yan/zi-jie-ma/zi-jie-ma-cao-zong.md)
    * [如何查看类编译后的字节码指令](java-yu-yan/zi-jie-ma/ru-he-cha-kan-lei-bian-yi-hou-de-zi-jie-ma-zhi-ling.md)
    * [字节码指令有哪些](java-yu-yan/zi-jie-ma/zi-jie-ma-zhi-ling-you-na-xie.md)
* [Python](python/README.md)
  * [异常处理](python/yi-chang-chu-li.md)
* [Go](go-yu-yan.md)
* [数据结构与算法](suan-fa/README.md)
  * [数据结构](suan-fa/shu-ju-jie-gou.md)
    * [概述](suan-fa/gai-shu.md)
      * [线性表](suan-fa/gai-shu/xian-xing-biao.md)
      * [栈](suan-fa/gai-shu/zhan.md)
      * [队列](suan-fa/gai-shu/dui-lie.md)
      * [串](suan-fa/gai-shu/chuan.md)
      * [树](suan-fa/gai-shu/shu.md)
      * [图](suan-fa/gai-shu/tu.md)
    * [Java的一些实现](suan-fa/javade-yi-xie-shi-xian.md)
    * [红黑树](suan-fa/hong-hei-shu.md)
    * [双缓冲队列](suan-fa/shuang-huan-chong-dui-lie.md)
    * [跳表SkipList](suan-fa/tiao-biao-skiplist.md)
  * [算法](suan-fa/suan-fa.md)
    * [概述](suan-fa/zhun-bei-si-lu.md)
    * [常见算法](suan-fa/chang-jian-suan-fa.md)
      * [基本排序](suan-fa/chang-jian-suan-fa/ji-ben-pai-xu.md)
      * [高级排序](suan-fa/chang-jian-suan-fa/gao-ji-pai-xu.md)
      * [动态规划](suan-fa/chang-jian-suan-fa/dong-tai-gui-hua.md)
* [框架或工具](kuang-jia-huo-gong-ju/README.md)
  * [Spring](kuang-jia-huo-gong-ju/spring/README.md)
    * [Spring基础](kuang-jia-huo-gong-ju/spring/springji-chu.md)
      * [Spring整体架构](kuang-jia-huo-gong-ju/spring/springji-chu/springzheng-ti-jia-gou.md)
      * [什么是IoC](kuang-jia-huo-gong-ju/spring/springji-chu/shi-yao-shi-ioc.md)
      * [Ioc容器的基本实现](kuang-jia-huo-gong-ju/spring/springji-chu/rong-qi-de-ji-ben-shi-xian.md)
      * [Spring的MainClass](kuang-jia-huo-gong-ju/spring/springji-chu/springshi-xian-zhong-de-zhu-yao-lei.md)
        * [Spring的BeanFactory](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu.md)
        * [Spring的Register](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-register.md)
        * [Spring的Resource和ResourceLoader](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-resource.md)
        * [Spring的PropertySource](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-propertysource.md)
        * [Spring的PropertyResolver](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-propertyresolver.md)
        * [Spring的PropertyEditor](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-property.md)
        * [Spring的Convert](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/s-pringzhong-de-conversionservice.md)
        * [Spring的BeanDefinition](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/iocshi-xian-zhong-de-zhu-yao-lei-tu-2.md)
        * [Spring的BeanDefinitionReader](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-beandefinitionreader.md)
        * [Spring的BeanDefiniton其他Reader](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-beandefiniton-qi-ta-reader.md)
        * [Spring的BeanDefinition其他Reader2](kuang-jia-huo-gong-ju/spring/springji-chu/springde-beandefinition-qi-ta-reader2.md)
        * [Spring的Aware](kuang-jia-huo-gong-ju/spring/springji-chu/iocshi-xian-zhong-de-zhu-yao-lei-tu/springde-aware.md)
        * [Spring的BeanFctoryPostProcessor](kuang-jia-huo-gong-ju/spring/springji-chu/springde-beanfctorypostprocessor.md)
        * [Spring的BeanPostProcessor](kuang-jia-huo-gong-ju/spring/springji-chu/springde-beanpostprocessor.md)
        * [Spring的Listener](kuang-jia-huo-gong-ju/spring/springji-chu/springzhong-de-listener.md)
      * [Xml格式的应用启动](kuang-jia-huo-gong-ju/spring/springji-chu/beande-sheng-ming-zhou-qi.md)
        * [Xml格式的应用启动2](kuang-jia-huo-gong-ju/spring/springji-chu/beande-sheng-ming-zhou-qi/xmlge-shi-de-ying-yong-qi-dong-de-guo-cheng.md)
        * [Xml格式的应用启动3](kuang-jia-huo-gong-ju/spring/springji-chu/beande-sheng-ming-zhou-qi/xmlge-shi-de-ying-yong-qi-dong-de-guo-cheng-2.md)
        * [Xml格式的应用启动4](kuang-jia-huo-gong-ju/spring/springji-chu/beande-sheng-ming-zhou-qi/xmlge-shi-de-ying-yong-qi-dong-4.md)
        * [Xml格式的应用启动5](kuang-jia-huo-gong-ju/spring/springji-chu/beande-sheng-ming-zhou-qi/xmlge-shi-de-ying-yong-qi-dong-5.md)
        * [Xml格式的应用启动6](kuang-jia-huo-gong-ju/spring/springji-chu/beande-sheng-ming-zhou-qi/xmlge-shi-de-ying-yong-qi-dong-6.md)
        * [Xml格式的应用启动7](kuang-jia-huo-gong-ju/spring/springji-chu/beande-sheng-ming-zhou-qi/xmlge-shi-de-ying-yong-qi-dong-7.md)
      * [Spring中的设计模式](kuang-jia-huo-gong-ju/spring/springji-chu/springzhong-de-she-ji-mo-shi.md)
      * [什么是AOP](kuang-jia-huo-gong-ju/spring/springji-chu/shi-yao-shi-aop.md)
      * [Spring中AOP的实现](kuang-jia-huo-gong-ju/spring/springji-chu/springzhong-aop-de-shi-xian.md)
    * [Spring应用](kuang-jia-huo-gong-ju/spring/springying-yong.md)
      * [Spring的事务控制](kuang-jia-huo-gong-ju/spring/springji-chu/springde-shi-wu-kong-zhi.md)
      * [@Transactional注解在什么情况下会失效](kuang-jia-huo-gong-ju/spring/transactional-zhu-jie-zai-shi-mo-qing-kuang-xia-hui-shi-xiao.md)
      * [如何在数据库事务提交成功后进行异步操作](kuang-jia-huo-gong-ju/spring/ru-he-zai-shu-ju-ku-shi-wu-ti-jiao-cheng-gong-hou-jin-hang-yi-bu-cao-zuo.md)
      * [Spring中定时任务的原理](kuang-jia-huo-gong-ju/spring/spring-zhong-ding-shi-ren-wu-de-yuan-li.md)
  * [SpringMVC](kuang-jia-huo-gong-ju/springmvc/README.md)
    * [Controller是如何将参数和前端传来的数据一一对应的](kuang-jia-huo-gong-ju/springmvc/controller-shi-ru-he-jiang-can-shu-he-qian-duan-chuan-lai-de-shu-ju-yi-yi-dui-ying-de.md)
    * [请求处理流程](kuang-jia-huo-gong-ju/springmvc/qing-qiu-chu-li-liu-cheng.md)
  * [Zookeeper](kuang-jia-huo-gong-ju/zookeeper/README.md)
    * [Zookeeper是什么](kuang-jia-huo-gong-ju/zookeeper/zookeeper-shi-shi-mo.md)
    * [Zookeeper能干啥](kuang-jia-huo-gong-ju/zookeeper/zookeeper-neng-gan-sha.md)
  * [Shiro](kuang-jia-huo-gong-ju/shiro.md)
  * [druid](kuang-jia-huo-gong-ju/druid.md)
  * [Netty](kuang-jia-huo-gong-ju/netty.md)
  * [Consul](kuang-jia-huo-gong-ju/consul/README.md)
    * [Consul是什么](kuang-jia-huo-gong-ju/consul/consul-shi-shen-me.md)
  * [etcd](kuang-jia-huo-gong-ju/etcd.md)
  * [confd](kuang-jia-huo-gong-ju/confd.md)
  * [Akka](kuang-jia-huo-gong-ju/akka/README.md)
    * [Actor模型是什么](kuang-jia-huo-gong-ju/akka/actor-mo-xing-shi-shen-me.md)
* [数据库](shu-ju-ku/README.md)
  * [基本概念](shu-ju-ku/mysql/ji-ben-gai-nian.md)
  * [MySQL](shu-ju-ku/mysql/README.md)
    * [基本配置](shu-ju-ku/mysql/ji-ben-pei-zhi.md)
    * [MySQL数据类型](shu-ju-ku/mysql/mysqlzhong-de-shu-ju-lei-xing.md)
    * [MySQL存储引擎](shu-ju-ku/mysql/mysqlcun-chu-yin-qing.md)
    * [MySQL事务](shu-ju-ku/mysql/mysqlshi-wu.md)
      * [MySQL事务概念](shu-ju-ku/mysql/mysqlshi-wu/mysqlshi-wu-gai-nian.md)
    * [MySQL索引](shu-ju-ku/mysql/mysqlsuo-yin.md)
      * [MySQL中的索引类型](shu-ju-ku/mysql/mysqlzhong-de-suo-yin-lei-xing.md)
      * [B-Tree/B+Tree概述](suan-fa/b-treeb+treegai-shu.md)
      * [为什么使用B+Tree](shu-ju-ku/mysql/nei-cun-he-ci-pan-cun-qu-yuan-li.md)
      * [MySQL中的B+Tree索引](shu-ju-ku/mysql/mysqlzhong-deb-+-tree-suo-yin.md)
      * [MySQL高性能索引策略](shu-ju-ku/mysql/mysqlcha-xun-you-hua.md)
    * [MySQL查询](shu-ju-ku/mysql/mysqlcha-xun.md)
      * [MySQL查询过程](shu-ju-ku/mysql/mysqlcha-xun-guo-cheng.md)
      * [MySQL查询性能优化](shu-ju-ku/mysql/mysqlcha-xun-xing-neng-you-hua.md)
      * [使用EXPLAIN](shu-ju-ku/mysql/shi-yong-explain.md)
    * [MySQL锁](shu-ju-ku/mysql/mysqlsuo.md)
      * [MySQL中锁概述](shu-ju-ku/mysql/mysqlsuo/mysqlzhong-suo-de-fen-lei.md)
      * [InnoDB的并发控制](shu-ju-ku/mysql/mysqlsuo/innodbde-mvcc.md)
      * [MySQL乐观锁](shu-ju-ku/mysql/mysqlshi-zhan/mysqlle-guan-suo.md)
    * [MySQL分库分表](shu-ju-ku/mysql/mysqlzhong-de-sharding.md)
      * [分库/分表](shu-ju-ku/mysql/mysqlzhong-de-sharding/gai-nian-ff1a-fen-5e93-fen-8868-fen-qu.md)
      * [跨库JOIN](shu-ju-ku/mysql/mysqlzhong-de-sharding/fen-ku-fen-biao-de-wen-ti.md)
      * [跨库分页](shu-ju-ku/mysql/mysqlzhong-de-sharding/kua-ku-fen-ye.md)
      * [分库分表后的平滑扩容](shu-ju-ku/mysql/mysqlzhong-de-sharding/fen-ku-fen-biao-hou-de-ping-hua-kuo-rong.md)
      * [分区表](shu-ju-ku/mysql/mysqlzhong-de-sharding/fen-qu-biao.md)
      * [分布式ID生成方法](shu-ju-ku/mysql/mysqlzhong-de-sharding/fen-bu-shi-id-sheng-cheng-fang-fa.md)
    * [MySQL实战](shu-ju-ku/mysql/mysqlshi-zhan.md)
      * [在线表结构变更](shu-ju-ku/mysql/mysqlshi-zhan/zai-xian-biao-jie-gou-bian-geng.md)
      * [MySQL优化规则](shu-ju-ku/mysql/mysqlshi-zhan/mysqlyou-hua-gui-ze.md)
      * [MySQL问题排查](shu-ju-ku/mysql/mysqlshi-zhan/mysqlwen-ti-pai-cha.md)
      * [常见查询场景](shu-ju-ku/mysql/mysqlshi-zhan/chang-jian-cha-xun-chang-jing.md)
  * [Redis](shu-ju-ku/redis.md)
  * [Hbase](shu-ju-ku/hbase.md)
  * [OpenTSDB](shu-ju-ku/opentsdb.md)
  * [rrd](shu-ju-ku/rrd.md)
  * [MongoDB](shu-ju-ku/mongodb.md)
  * [连接池](shu-ju-ku/lian-jie-chi.md)
* [系统设计](xi-tong-she-ji/README.md)
  * [一致性Hash算法](xi-tong-she-ji/yi-zhi-xing-hash-suan-fa.md)
  * [限流](xi-tong-she-ji/xian-liu/README.md)
    * [限流是什么](xi-tong-she-ji/xian-liu/xian-liu-shi-shen-me.md)
    * [限流算法](xi-tong-she-ji/xian-liu/xian-liu-suan-fa.md)
    * [应用内限流](xi-tong-she-ji/xian-liu/ying-yong-nei-xian-liu.md)
    * [分布式限流](xi-tong-she-ji/xian-liu/fen-bu-shi-xian-liu.md)
    * [接入层限流](xi-tong-she-ji/xian-liu/jie-ru-ceng-xian-liu/README.md)
      * [ngx\_http\_limit\_conn\_module](xi-tong-she-ji/xian-liu/jie-ru-ceng-xian-liu/ngx_http_limit_conn_module.md)
      * [ngx\_http\_limit\_req\_module](xi-tong-she-ji/xian-liu/jie-ru-ceng-xian-liu/ngx_http_limit_req_module.md)
      * [lua\_resty\_limit-tarffic](xi-tong-she-ji/xian-liu/jie-ru-ceng-xian-liu/lua_resty_limit-tarffic.md)
    * [节流](xi-tong-she-ji/xian-liu/jie-liu.md)
  * [降级](xi-tong-she-ji/jiang-ji/README.md)
    * [降级详解](xi-tong-she-ji/jiang-ji/zi-dong-kai-guan-jiang-ji.md)
    * [人工降级开关的实现](xi-tong-she-ji/jiang-ji/ren-gong-kai-fa-jiang-ji.md)
    * [自动降级的实现：Hystrix](xi-tong-she-ji/jiang-ji/du-fu-wu-jiang-ji.md)
  * [负载均衡](xi-tong-she-ji/fu-zai-jun-heng/README.md)
    * [概述](xi-tong-she-ji/fu-zai-jun-heng/gai-shu.md)
    * [互联网架构下的负载均衡](xi-tong-she-ji/fu-zai-jun-heng/hu-lian-wang-jia-gou-xia-de-fu-zai-jun-heng.md)
    * [Nginx负载均衡（七层）](xi-tong-she-ji/fu-zai-jun-heng/nginx-fu-zai-jun-heng.md)
    * [Nginx负载均衡（四层）](xi-tong-she-ji/fu-zai-jun-heng/nginx-fu-zai-jun-heng-si-ceng.md)
    * [Nginx动态配置](xi-tong-she-ji/fu-zai-jun-heng/nginx-dong-tai-pei-zhi.md)
  * [超时与重试机制](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/README.md)
    * [什么地方要超时与重试](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/shen-me-di-fang-yao-chao-shi-yu-zhong-shi.md)
    * [代理层超时与重试](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/dai-li-ceng-chao-shi-yu-zhong-shi.md)
    * [Web容器超时](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/web-rong-qi-chao-shi.md)
    * [中间件客户端超时与重试](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/zhong-jian-jian-ke-hu-duan-chao-shi-yu-zhong-shi.md)
    * [数据库超时](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/shu-ju-ku-ke-hu-duan-chao-shi.md)
    * [NoSQL客户端超时设置](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/nosql-ke-hu-duan-chao-shi-she-zhi.md)
    * [业务超时](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/ye-wu-chao-shi.md)
    * [前端请求超时](xi-tong-she-ji/chao-shi-yu-zhong-shi-ji-zhi/qian-duan-qing-qiu-chao-shi.md)
  * [网关](xi-tong-she-ji/wang-guan.md)
  * [CAP](xi-tong-she-ji/cap/README.md)
    * [什么是CAP](xi-tong-she-ji/cap/shen-me-shi-cap.md)
    * [CAP理解](xi-tong-she-ji/cap/cap-li-jie.md)
  * [生产者-消费者模型](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/README.md)
    * [使用notify/wait方式](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/shi-yong-notify-wait-fang-shi.md)
    * [使用await/signal实现](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/shi-yong-await-signal-shi-xian.md)
    * [使用阻塞队列实现](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/shi-yong-zu-sai-dui-lie-shi-xian.md)
    * [使用信号量实现](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/shi-yong-xin-hao-liang-shi-xian.md)
    * [使用管道流实现](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/shi-yong-guan-dao-liu-shi-xian.md)
    * [无锁队列Disruptor](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/wu-suo-dui-lie-disruptor.md)
    * [双缓冲队列](xi-tong-she-ji/sheng-chan-zhe-xiao-fei-zhe-mo-xing/huan-chong-dui-lie.md)
  * [缓存](xi-tong-she-ji/huan-cun-fang-an.md)
    * [缓存概述](xi-tong-she-ji/huan-cun-fang-an/huan-cun-gai-shu.md)
    * 数据库缓存
    * 应用缓存
    * 前端缓存
    * [本地缓存](xi-tong-she-ji/huan-cun-fang-an/ben-di-huan-cun.md)
  * [秒杀](xi-tong-she-ji/miao-sha.md)
  * LRU
* [版本控制](ban-ben-kong-zhi/README.md)
  * [Git](ban-ben-kong-zhi/git/README.md)
    * [Git常用命令](ban-ben-kong-zhi/git/git-chang-yong-ming-ling.md)
    * [场景命令](ban-ben-kong-zhi/git/chang-jing-ming-ling.md)
  * [Svn](ban-ben-kong-zhi/svn.md)
* [计算机操作系统](ji-suan-ji-cao-zuo-xi-tong/README.md)
  * [Linux](ji-suan-ji-cao-zuo-xi-tong/linux/README.md)
    * [Linux中重要概念](ji-suan-ji-cao-zuo-xi-tong/linux/linux-zhong-nei-cun-buffer-he-cache-de-qu-bie.md)
    * [常用命令](ji-suan-ji-cao-zuo-xi-tong/linux/chang-yong-ming-ling.md)
    * [查看日志](ji-suan-ji-cao-zuo-xi-tong/linux/cha-kan-ri-zhi.md)
    * [权限管理](ji-suan-ji-cao-zuo-xi-tong/linux/quan-xian-guan-li.md)
    * [登录或传输](ji-suan-ji-cao-zuo-xi-tong/linux/deng-lu-huo-chuan-shu.md)
    * [防火墙](ji-suan-ji-cao-zuo-xi-tong/linux/fang-huo-qiang.md)
    * [配置ssh免密](ji-suan-ji-cao-zuo-xi-tong/linux/pei-zhi-ssh-mian-mi.md)
    * [进程](ji-suan-ji-cao-zuo-xi-tong/linux/jin-cheng.md)
    * [防火墙](ji-suan-ji-cao-zuo-xi-tong/linux/fang-huo-qiang-1.md)
  * [Mac](ji-suan-ji-cao-zuo-xi-tong/mac.md)
  * [计算机基础](ji-suan-ji-cao-zuo-xi-tong/ji-suan-ji-ji-chu/README.md)
    * [进制](ji-suan-ji-cao-zuo-xi-tong/ji-suan-ji-ji-chu/jin-zhi.md)
    * [Java中的位运算](ji-suan-ji-cao-zuo-xi-tong/ji-suan-ji-ji-chu/java-zhong-de-wei-yun-suan.md)
    * [计算机存储系统结构](ji-suan-ji-cao-zuo-xi-tong/ji-suan-ji-ji-chu/ji-suan-ji-cun-chu-xi-tong-jie-gou.md)
* [网络](wang-luo/README.md)
  * [TCP三次握手和四次挥手](wang-luo/tcp-san-ci-wo-shou-he-si-ci-hui-shou.md)
  * [网络术语](wang-luo/wang-luo-shu-yu/README.md)
    * [网关、路由器、交换机、IP等](wang-luo/wang-luo-shu-yu/wang-guan-lu-you-qi-jiao-huan-ji-ip-deng.md)
    * [VLAN](wang-luo/wang-luo-shu-yu/vlan.md)
    * [LAN](wang-luo/wang-luo-shu-yu/lan.md)
* [设计模式](she-ji-mo-shi/README.md)
  * [设计模式概述](she-ji-mo-shi/she-ji-mo-shi-gai-shu.md)
  * [创建型](she-ji-mo-shi/chuang-jian-xing/README.md)
    * [单例模式](she-ji-mo-shi/chuang-jian-xing/dan-li-mo-shi.md)
    * [工厂模式](she-ji-mo-shi/chuang-jian-xing/gong-chang-mo-shi.md)
    * [建造者模式](she-ji-mo-shi/chuang-jian-xing/jian-zao-zhe-mo-shi.md)
    * [原型模式](she-ji-mo-shi/chuang-jian-xing/yuan-xing-mo-shi.md)
    * [享元模式](she-ji-mo-shi/chuang-jian-xing/xiang-yuan-mo-shi.md)
  * [行为型](she-ji-mo-shi/hang-wei-xing/README.md)
    * [观察者模式](she-ji-mo-shi/hang-wei-xing/guan-cha-zhe-mo-shi.md)
    * [策略模式](she-ji-mo-shi/hang-wei-xing/ce-lve-mo-shi.md)
    * [模板模式](she-ji-mo-shi/hang-wei-xing/mo-ban-mo-shi.md)
    * [责任链模式](she-ji-mo-shi/hang-wei-xing/ze-ren-lian-mo-shi.md)
    * [命令模式](she-ji-mo-shi/hang-wei-xing/ming-ling-mo-shi.md)
    * [外观模式](she-ji-mo-shi/hang-wei-xing/wai-guan-mo-shi.md)
    * [迭代器模式](she-ji-mo-shi/hang-wei-xing/die-dai-qi-mo-shi.md)
    * [中介者模式](she-ji-mo-shi/hang-wei-xing/zhong-jie-zhe-mo-shi/README.md)
      * [中介模式续](she-ji-mo-shi/hang-wei-xing/zhong-jie-zhe-mo-shi/zhong-jie-mo-shi-xu.md)
    * [状态模式](she-ji-mo-shi/hang-wei-xing/zhuang-tai-mo-shi/README.md)
      * [状态模式实例](she-ji-mo-shi/hang-wei-xing/zhuang-tai-mo-shi/zhuang-tai-mo-shi-shi-li.md)
      * [状态模式思考](she-ji-mo-shi/hang-wei-xing/zhuang-tai-mo-shi/zhuang-tai-mo-shi-si-kao.md)
    * [访问者模式](she-ji-mo-shi/hang-wei-xing/fang-wen-zhe-mo-shi/README.md)
      * [访问者实例1](she-ji-mo-shi/hang-wei-xing/fang-wen-zhe-mo-shi/fang-wen-zhe-shi-li-1.md)
      * [访问者模式续](she-ji-mo-shi/hang-wei-xing/fang-wen-zhe-mo-shi/fang-wen-zhe-mo-shi-xu.md)
  * [结构型](she-ji-mo-shi/jie-gou-xing/README.md)
    * [组合模式](she-ji-mo-shi/jie-gou-xing/zu-he-mo-shi/README.md)
      * [组合模式续](she-ji-mo-shi/jie-gou-xing/zu-he-mo-shi/zu-he-mo-shi-xu.md)
    * [装饰模式](she-ji-mo-shi/jie-gou-xing/zhuang-shi-mo-shi/README.md)
      * [装饰模式续](she-ji-mo-shi/jie-gou-xing/zhuang-shi-mo-shi/zhuang-shi-mo-shi-xu.md)
    * [代理模式](she-ji-mo-shi/jie-gou-xing/dai-li-mo-shi.md)
    * [备忘录模式](she-ji-mo-shi/jie-gou-xing/bei-wang-lu-mo-shi.md)
    * [桥接模式](she-ji-mo-shi/jie-gou-xing/qiao-jie-mo-shi/README.md)
      * [桥接模式实例一](she-ji-mo-shi/jie-gou-xing/qiao-jie-mo-shi/qiao-jie-mo-shi-shi-li-yi.md)
* [构建工具](gou-jian-gong-ju/README.md)
  * [Maven](gou-jian-gong-ju/maven/README.md)
    * [常用命令](gou-jian-gong-ju/maven/chang-yong-ming-ling.md)
    * [Maven生命周期](gou-jian-gong-ju/maven/maven-sheng-ming-zhou-qi.md)
    * [Maven中的变量和属性](gou-jian-gong-ju/maven/maven-zhong-de-bian-liang-he-shu-xing.md)
    * [不同环境的如何配置不同的变量](gou-jian-gong-ju/maven/bu-tong-huan-jing-de-ru-he-pei-zhi-bu-tong-de-bian-liang.md)
    * [常用插件及配置](gou-jian-gong-ju/maven/chang-yong-cha-jian-ji-pei-zhi.md)
    * [其他问题](gou-jian-gong-ju/maven/qi-ta-wen-ti.md)
    * [dependencies与dependencyManagement的区别](gou-jian-gong-ju/maven/dependencies-yu-dependencymanagement-de-qu-bie.md)
  * [Gradle](gou-jian-gong-ju/gradle.md)
* [大数据](da-shu-ju/README.md)
  * [Hadoop](da-shu-ju/hadoop.md)
  * [Storm](da-shu-ju/storm.md)
  * [Spark](da-shu-ju/spark.md)
* [服务器](fu-wu-qi/README.md)
  * [Tomcat](fu-wu-qi/tomcat/README.md)
    * [server.xml配置详解](fu-wu-qi/tomcat/tomcat-pei-zhi.md)
    * [线程池和连接数配置](fu-wu-qi/tomcat/xian-cheng-chi-he-lian-jie-shu-pei-zhi.md)
    * [Maven远程部署](fu-wu-qi/tomcat/rang-tomcat-zhi-chi-maven-yuan-cheng-bu-shu.md)
    * [一些小技巧](fu-wu-qi/tomcat/yi-xie-xiao-ji-qiao.md)
    * [Tomcat类加载机制分析](fu-wu-qi/tomcat/tomcat-lei-jia-zai-ji-zhi-fen-xi.md)
    * [Tomcat的日志](fu-wu-qi/tomcat/tomcat-de-ri-zhi.md)
    * [Tomcat架构](fu-wu-qi/tomcat/tomcat-jia-gou/README.md)
      * [概述](fu-wu-qi/tomcat/tomcat-jia-gou/gai-shu.md)
      * [Server 的启动流程](fu-wu-qi/tomcat/tomcat-jia-gou/server-de-qi-dong-liu-cheng.md)
      * [请求处理流程](fu-wu-qi/tomcat/tomcat-jia-gou/qing-qiu-chu-li-liu-cheng.md)
  * [Nginx](fu-wu-qi/nginx/README.md)
    * [常用命令](fu-wu-qi/nginx/chang-yong-ming-ling.md)
    * [基本配置](fu-wu-qi/nginx/ji-ben-pei-zhi.md)
    * [Lua](fu-wu-qi/nginx/lua.md)
  * [Tengine](fu-wu-qi/tengine.md)
* [中间件](zhong-jian-jian/README.md)
  * [任务调度](zhong-jian-jian/ren-wu-tiao-du/README.md)
    * [为什么需要任务调度](zhong-jian-jian/ren-wu-tiao-du/wei-shi-mo-xu-yao-ren-wu-tiao-du.md)
  * [消息队列](zhong-jian-jian/xiao-xi-dui-lie/README.md)
    * [为什么需要消息队列](zhong-jian-jian/xiao-xi-dui-lie/wei-shi-mo-xu-yao-xiao-xi-dui-lie.md)
    * [消息队列关键点](zhong-jian-jian/xiao-xi-dui-lie/xiao-xi-dui-lie-guan-jian-dian.md)
    * [消息中间件需要解决的问题](zhong-jian-jian/xiao-xi-dui-lie/xiao-xi-zhong-jian-jian-xu-yao-jie-jue-na-xie-wen-ti.md)
    * [不同消息队列产品对比](zhong-jian-jian/xiao-xi-dui-lie/bu-tong-xiao-xi-dui-lie-chan-pin-dui-bi.md)
    * [RocketMQ](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/README.md)
      * [快速入门](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/kuai-su-ru-men.md)
      * [整体架构](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zheng-ti-jia-gou.md)
      * [部署方式](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/untitled/README.md)
        * [Broker部署方案](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/untitled/broker-bu-shu-fang-an.md)
      * [客户端使用](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/README.md)
        * [客户端使用指南](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/ke-hu-duan-shi-yong-zhi-nan.md)
        * [快速开始](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/kuai-su-kai-shi.md)
        * [简单示例](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/untitled.md)
        * [有序消息示例](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/you-xu-xiao-xi-shi-li.md)
        * [广播消息示例](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/guang-bo-xiao-xi-shi-li.md)
        * [定时消息示例](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/ding-shi-xiao-xi-shi-li.md)
        * [批量消息示例](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/pi-liang-xiao-xi-shi-li.md)
        * [过滤消息示例](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/guo-lv-xiao-xi-shi-li.md)
        * [日志输出配置示例](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/ke-hu-duan-shi-yong/ri-zhi-shu-chu-pei-zhi-shi-li.md)
      * [关键点实现](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/guan-jian-dian-shi-xian/README.md)
        * [顺序消息的实现](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/guan-jian-dian-shi-xian/shun-xu-xiao-xi-de-shi-xian.md)
      * [最佳实践](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/README.md)
        * [Broker的最佳实践](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/broker-de-zui-jia-shi-jian.md)
        * [生产者最佳实践](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/sheng-chan-zhe-zui-jia-shi-jian/README.md)
          * [生产者最佳实践续](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/sheng-chan-zhe-zui-jia-shi-jian/sheng-chan-zhe-zui-jia-shi-jian-xu.md)
        * [消费者最佳实践](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/xiao-fei-zhe-zui-jia-shi-jian/README.md)
          * [消费者最佳实践续](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/xiao-fei-zhe-zui-jia-shi-jian/xiao-fei-zhe-zui-jia-shi-jian-xu.md)
        * [名称服务最佳实践](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/ming-cheng-fu-wu-zui-jia-shi-jian.md)
        * [JVM/kernel配置的最佳实践](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/jvmkernel-pei-zhi-de-zui-jia-shi-jian.md)
        * [新特性 Filter Server](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/xin-te-xing-filter-server.md)
        * [其他事项](zhong-jian-jian/xiao-xi-dui-lie/robbitmq/zui-jia-shi-jian/qi-ta-shi-xiang.md)
    * [RabbitMQ](zhong-jian-jian/xiao-xi-dui-lie/rocketmq.md)
    * [Kafka](zhong-jian-jian/xiao-xi-dui-lie/kafka.md)
  * [分布式事务](zhong-jian-jian/fen-bu-shi-shi-wu/README.md)
    * [什么是分布式事务](zhong-jian-jian/fen-bu-shi-shi-wu/shi-mo-shi-fen-bu-shi-shi-wu.md)
    * [解决方案](zhong-jian-jian/fen-bu-shi-shi-wu/jie-jue-fang-an.md)
  * [服务治理](zhong-jian-jian/fu-wu-zhi-li/README.md)
    * [RPC概念](zhong-jian-jian/fu-wu-zhi-li/rpc-gai-nian.md)
    * [RPC最简实现](zhong-jian-jian/fu-wu-zhi-li/rpc-zui-jian-shi-xian.md)
    * [为什么需要服务治理](zhong-jian-jian/fu-wu-zhi-li/wei-shen-me-xu-yao-fu-wu-zhi-li.md)
    * [Dubbo](zhong-jian-jian/fu-wu-zhi-li/dubbo/README.md)
      * [Dubbo整体架构](zhong-jian-jian/fu-wu-zhi-li/dubbo/dubbo-zheng-ti-jia-gou.md)
    * [Java RMI](zhong-jian-jian/fu-wu-zhi-li/rmi.md)
  * [分布式锁](zhong-jian-jian/fen-bu-shi-suo/README.md)
    * [如何设计分布式锁](zhong-jian-jian/fen-bu-shi-suo/ru-he-she-ji-fen-bu-shi-suo/README.md)
      * [基于zookeeper](zhong-jian-jian/fen-bu-shi-suo/ru-he-she-ji-fen-bu-shi-suo/ji-yu-zookeeper.md)
      * [基于Redis](zhong-jian-jian/fen-bu-shi-suo/ru-he-she-ji-fen-bu-shi-suo/ji-yu-redis.md)
  * [注册中心](zhong-jian-jian/zhu-ce-zhong-xin/README.md)
    * [注册中心的职责](zhong-jian-jian/zhu-ce-zhong-xin/zhu-ce-zhong-xin-de-zhi-ze.md)
    * [不同注册中心的比较](zhong-jian-jian/zhu-ce-zhong-xin/bu-tong-zhu-ce-zhong-xin-de-bi-jiao.md)
  * [配置中心](zhong-jian-jian/pei-zhi-zhong-xin/README.md)
    * [概述](zhong-jian-jian/pei-zhi-zhong-xin/pei-zhi-zhong-xin-shi-shen-me.md)
    * [配置中心的实现与选型](zhong-jian-jian/pei-zhi-zhong-xin/pei-zhi-zhong-xin-zen-me-zuo.md)
* [Web开发](web-kai-fa/README.md)
  * [Http请求类型及区别](web-kai-fa/http-qing-qiu-lei-xing-ji-qu-bie.md)
  * [常见的content-type](web-kai-fa/chang-jian-de-contenttype.md)
  * [如何处理跨域](web-kai-fa/ru-he-chu-li-kua-yu.md)
  * [Restful最佳实践](web-kai-fa/restful-zui-jia-shi-jian.md)
  * [HTTP状态码](web-kai-fa/http-zhuang-tai-ma.md)
  * [Http下载原理](web-kai-fa/httpxia-zai-yuan-li.md)
* [测试](ce-shi/README.md)
  * [压测:apache bench](ce-shi/ya-ce-ff0d-apache-bench.md)
  * [压测:Jmeter](ce-shi/ya-6d4b-jmeter.md)

