# 四种引用类型区别及何时回收

**为什么要分类**

希望能描述这样一类对象：当内存空间还足够时，则能保留在内存中；如果内存空间在进行垃圾收集后还是非常紧张，则可以抛弃这些对象。很多系统的缓存功能都符合这样的应用对象。  
JDK1.2之后，Java对引用的概念进行可扩充，将引用分为（引用强度依次减低的顺序）：强引用、软引用、弱引用、虚引用。

**强引用**

是在在程序代码中类似`Object obj = new Object()`这类的普遍存在的引用。只要强引用还在，垃圾收集器就不会回收被引用的对象。

**软引用**

用来描述有用但非必须的对象。在系统将要发生内存溢出异常时，会把这些对象进行回收，如果还是内存不足，才会抛内存不足异常。使用SoftReference类来实现软引用。

**弱引用**

描述非必须对象，将会在下一次垃圾回收的时候进行回收（无论内存是否够用）。使用WeakReference类来实现弱引用。

**虚引用**

一个对象是否有虚引用的存在，完全不会对其生存时间构成影响，也无法通过一个虚引用来获取一个实例对象。为一个对象设置一个虚引用的唯一目的就是：在这个对象被收集器回收时收到一个系统通知。使用PhantomReference类来实现虚引用。



