# 权限管理

先看输出样式：

```text
[root@www /]# ls -l
total 64
dr-xr-xr-x   2 root root 4096 Dec 14  2012 bin
dr-xr-xr-x   4 root root 4096 Apr 19  2012 boot
-r-xr-xr-x   4 root root 4096 Apr 19  2012 aa.txt
```

**文件类型**

\[d\]表示是目录，

\[-\]表示是文件，

\[l\]表示是链接文档；

\[_b_\]表示为装置文件里面的可供储存的接口设备\(可随机存取装置\)；

\[_c_\]表示为装置文件里面的串行端口设备，例如键盘、鼠标\(一次性读取装置\)。

**『rwx』 权限**

其中，

\[ r \]代表可读\(read\)

\[ w \]代表可写\(write\)

\[ x \]代表可执行\(execute\)

\[ - \]表示没有相应权限

要注意的是，这三个权限的位置不会改变。

**权限分组**

属主权限\|属组权限\|其他用户权限

r-x\|r-x\|r-x

即，Linux系统按**文件所有者**、**文件所有者同组用户**和**其他用户**来规定了不同的文件访问权限。

一个用户属于一个或多个组。

**更改文件属主**

```text
chown [–R] 属主名 文件名
chown [-R] 属主名：属组名 文件名
```

**更改文文件权限**

『-rwxrwxrwx』， 这九个权限是三个三个一组的，其中，我们可以使用数字来代表各个权限：r是4，w是2，x是1，比如：

如果要将权限变成_-rwxr-xr--，_那么权限的分数就成为 \[4+2+1\]\[4+0+1\]\[4+0+0\]=754，可以执行：

```text
chmod 754 aa.txt
```

可以使用-R : 进行递归变更，即目录下的所有文件都会变更。

还有一种方式是u, g, o来代表\(1\)user \(2\)group \(3\)others三种身份，按下面这种格式进行修改文件权限

```text
chmod u=rwx,g=rx,o=r  aa.txt
```

