# LAN

**局域网**（**L**ocal **A**rea **N**etwork, **LAN**），又称**内网**。指覆盖局部区域（如办公室或楼层）的[计算机网络](https://zh.wikipedia.org/wiki/%E8%AE%A1%E7%AE%97%E6%9C%BA%E7%BD%91%E7%BB%9C)。

按照网络覆盖的区域（距离）不同，其他的网络类型还包括[个人网](https://zh.wikipedia.org/wiki/%E4%B8%AA%E4%BA%BA%E7%BD%91)、[城域网](https://zh.wikipedia.org/wiki/%E5%9F%8E%E5%9F%9F%E7%BD%91)、[广域网](https://zh.wikipedia.org/wiki/%E5%B9%BF%E5%9F%9F%E7%BD%91)等。

早期的局域网网络技术都是各不同厂家所专有，互不兼容。后来，[电机电子工程师学会](https://zh.wikipedia.org/wiki/%E9%9B%BB%E6%A9%9F%E9%9B%BB%E5%AD%90%E5%B7%A5%E7%A8%8B%E5%B8%AB%E5%AD%B8%E6%9C%83)推动了局域网技术的标准化，由此产生了[IEEE 802](https://zh.wikipedia.org/wiki/IEEE_802)系列标准。这使得在建设局域网时可以选用不同厂家的设备，并能保证其兼容性。这一系列标准覆盖了[双绞线](https://zh.wikipedia.org/wiki/%E5%8F%8C%E7%BB%9E%E7%BA%BF)、[同轴电缆](https://zh.wikipedia.org/wiki/%E5%90%8C%E8%BD%B4%E7%94%B5%E7%BC%86)、[光纤](https://zh.wikipedia.org/wiki/%E5%85%89%E7%BA%A4)和[无线](https://zh.wikipedia.org/wiki/%E6%97%A0%E7%BA%BF%E5%B1%80%E5%9F%9F%E7%BD%91)等多种传输媒介和组网方式，并包括网络测试和管理的内容。随着新技术的不断出现，这一系列标准仍在不断的更新变化之中。

[以太网](https://zh.wikipedia.org/wiki/%E4%BB%A5%E5%A4%AA%E7%BD%91)（[IEEE 802.3](https://zh.wikipedia.org/wiki/IEEE_802.3)标准）是最常用的局域网组网方式。以太网使用双绞线作为传输媒介。在没有中继的情况下，最远可以覆盖200米的范围。最普及的以太网类型数据传输速率为100Mb/s，更新的标准则支持1000Mb/s和10Gb/s的速率。

其他主要的局域网类型有[令牌环](https://zh.wikipedia.org/wiki/%E4%BB%A4%E7%89%8C%E7%8E%AF)和[FDDI](https://zh.wikipedia.org/wiki/%E5%85%89%E7%BA%A4%E5%88%86%E5%B8%83%E5%BC%8F%E6%95%B0%E6%8D%AE%E6%8E%A5%E5%8F%A3)（光纤分布数字接口，[IEEE 802.8](https://zh.wikipedia.org/w/index.php?title=IEEE_802.8&action=edit&redlink=1)）。令牌环网络采用同轴电缆作为传输媒介，具有更好的抗干扰性；但是网络结构不能很容易的改变。FDDI采用光纤传输，网络带宽大，适于用作连接多个局域网的骨干网。

近两年来，随着[802.11](https://zh.wikipedia.org/wiki/IEEE_802.11)标准的制定，[无线局域网](https://zh.wikipedia.org/wiki/%E6%97%A0%E7%BA%BF%E5%B1%80%E5%9F%9F%E7%BD%91)的应用大为普及。这一标准采用2.4GHz 和5.8GHz 的频段，数据传输速度最高可以达到300Mbps和866Mbps。

局域网标准定义了传输媒介、编码和介质访问等底层（一二层）功能。要使数据通过复杂的网络结构传输到达目的地，还需要具有寻址、路由和流量控制等功能的[网络协议](https://zh.wikipedia.org/wiki/%E7%BD%91%E7%BB%9C%E5%8D%8F%E8%AE%AE)的支持。[TCP/IP](https://zh.wikipedia.org/wiki/TCP/IP%E5%8D%8F%E8%AE%AE%E6%97%8F)（传输控制协议/互联网络协议）是最普遍使用的局域网网络协议。它也是[互联网](https://zh.wikipedia.org/wiki/%E4%BA%92%E8%81%94%E7%BD%91)所使用的网络协议。其他常用的局域网协议包括，[IPX](https://zh.wikipedia.org/wiki/%E4%BA%92%E8%81%94%E7%BD%91%E5%88%86%E7%BB%84%E4%BA%A4%E6%8D%A2%E5%8D%8F%E8%AE%AE)、[AppleTalk](https://zh.wikipedia.org/wiki/AppleTalk)等。



内容来源：[维基百科：局域网](https://zh.wikipedia.org/wiki/%E5%B1%80%E5%9F%9F%E7%BD%91)

