# 网关、路由器、交换机、IP等

首先，IP地址有A/B/C/D/E五种分类，而D和E分类为特殊地址，无需关注。只看前三类：

| 类别 | IP地址范围 | 默认子网掩码 | 最大网络数 | 最大主机数\(同一网段下\) |  |  |
| :--- | :--- | :--- | :--- | :--- | :--- | :--- |
| A类 | 1.0.0.0~126.255.255.255 | 255.0.0.0 | 126 | 2^24 - 2 |  |  |
| B类 | 128.0.0.0~191.255.255.255 | 255.255.0.0 | 2^14 | 2^16 - 2 |  |  |
| C类 | 192.0.0.0~223.255.255.255 | 255.255.255.0 | 2^21 | 2^8 - 2  |  |  |

从IP的写法组成上看：IP地址都是由**四段**组成，每个段是一个字节，8位，（换算成10进制）最大值是255。

从IP地址的含义来讲：IP地址由两部分组成，即[网络地址](http://baike.baidu.com/view/547479.htm)和[主机地址](http://baike.baidu.com/view/547482.htm)。其中，网络地址表示其属于互联网的哪一个网络，主机地址表示其属于该网络中的哪一台主机。二者是主从关系。

对于A类IP地址，1.x.x.x与2.x.x.x就是两个不同的网段，即前面第一个段决定了该IP的网络地址；

对于B类IP地址，128.0.x.x与128.1.x.x就是两个不同的网段，即前面两段决定了该IP的网络地址；

对于C类IP地址，192.0.0.x与192.0.1.x就是两个不同的网段，即前面三段决定了该IP的网络地址；

不同的网段之间的通信需要路由器，同一网段之间通信需要交换机。

子网掩码的作用就是决定一个IP地址中，哪些段属于网络地址，哪些端属于主机地址。与子网掩码中255对应IP段变化，则变化的是网段。与子网掩码中0对应IP段变化，则变化的是同一网段中的主机地址。



